"{ Package: 'jv:tea/compiler' }"

"{ NameSpace: Smalltalk }"

Object subclass:#TCompilerContext
	instanceVariableNames:'environment unit module'
	classVariableNames:''
	poolDictionaries:''
	category:'Languages-Tea-Compiler'
!

!TCompilerContext methodsFor:'accessing'!

environment
    ^ environment
!

environment:aTNamespaceDefinition
    environment := aTNamespaceDefinition.
!

module
    module isNil ifTrue:[ 
        module := LLVMModule newWithName: unit name.
    ].
    ^ module

    "Modified: / 30-08-2015 / 09:25:54 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

unit
    ^ unit
!

unit:aTCompilationUnit
    unit := aTCompilationUnit.
! !

!TCompilerContext methodsFor:'error reporting'!

reportTypeError: message

    TCompilerError raiseErrorString: message

    "Created: / 14-09-2015 / 14:20:03 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

