"{ Package: 'jv:tea/compiler' }"

"{ NameSpace: Smalltalk }"

TestCase subclass:#TCompilerExamples
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Languages-Tea-Compiler-Examples'
!

!TCompilerExamples class methodsFor:'asserting'!

isTestSelector:aSelector
    ^ (super isTestSelector:aSelector) or:[ aSelector startsWith: 'example' ]

    "Created: / 14-09-2015 / 11:56:04 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!TCompilerExamples methodsFor:'tests'!

example_if
    | environment unit compiler|

    environment := TNamespaceDefinition new.
    unit := TSourceReader read:'
nil subclass: #tBoolean
    category: ''tKernel-Builtins''
!! 

nil subclass: #tSIntegerW
    category: ''tKernel-Builtins''
!!
!!tSIntegerW methodsFor:''testing''!!
= another <tSIntegerW> <^ tBoolean> 
    %[:asm | 
        asm ret: (asm add: self _: another)
    %].
    "Following code is actually used only in hosted environment"
    ^ self + another
!! !!

!!tSIntegerW class methodsFor:''test''!!
threePlusFour <^ tSIntegerW> 
        ^ 3 + 4

!! !!
    '.

    compiler := TCompiler new.
    compiler compile: unit in: environment.
    self halt.
    "
    compiler context module
    "

    "Created: / 14-09-2015 / 12:14:27 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 14-09-2015 / 14:27:35 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

example_three_plus_four
    | environment unit compiler|

    environment := TNamespaceDefinition new.
    unit := TSourceReader read:'
nil subclass: #tSIntegerW
    category: ''tKernel''
!!
!!tSIntegerW methodsFor:''arithmetic''!!
+ another <tSIntegerW> <^ tSIntegerW> 
    %[:asm | 
        asm ret: (asm add: self _: another)
    %].
    "Following code is actually used only in hosted environment"
    ^ self + another
!! !!

!!tSIntegerW class methodsFor:''test''!!
threePlusFour <^ tSIntegerW> 
        ^ 3 + 4

!! !!
    '.

    compiler := TCompiler new.
    compiler compile: unit in: environment.
    self halt.
    "
    compiler context module
    "

    "Created: / 14-09-2015 / 11:56:57 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

