"{ Package: 'jv:tea/compiler' }"

"{ NameSpace: Smalltalk }"

TestCase subclass:#TSourceReaderTests
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Languages-Tea-Compiler-Model-Tests'
!

!TSourceReaderTests methodsFor:'tests'!

test_01
    | unit |

    unit := (TSourceReader read:'
tObject subclass: #tMachineInteger
    category: ''tKernel''
').
    self assert: unit classes size == 1.
    self assert: unit classes anElement isClass.
    self assert: (unit classes anElement superclassName =  'tObject').
    self assert: (unit classes anElement name ='tMachineInteger').
    self assert: (unit classes anElement category ='tKernel').

    "Created: / 31-08-2015 / 15:48:15 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 13-09-2015 / 09:02:17 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

test_02
    | unit |

    unit := TSourceReader read:'
tObject subclass: #tMachineInteger
    category: ''tKernel''     
!!

!!tMachineInteger class methodsFor: ''tests''!!
foo <^ tMachineInteger>
    ^ 1
'.
    self assert: unit classes size == 1.
    self assert: unit classes anElement isClass.
    self assert: (unit classes anElement theMetaclass methods size == 1).
    self assert: (unit classes anElement theMetaclass methods anElement className ='tMachineInteger class').
    self assert: (unit classes anElement theMetaclass methods anElement category ='tests').

    "Created: / 31-08-2015 / 16:34:55 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 14-09-2015 / 06:24:37 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

